package com.zswl.cloud.springBtach.server.core.task;

import com.github.microservice.components.data.mongo.timer.event.SimpleTaskTimerEvent;
import com.zswl.cloud.springBtach.server.core.domain.ScheduledTask;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.lang.reflect.Method;

@Slf4j
@Component
public class TaskTimerEvent implements SimpleTaskTimerEvent<ScheduledTask> {

    @Autowired
    private TaskLogic taskLogic;

    @SneakyThrows
    @Override
    public void execute(ScheduledTask entity) {
        Method method = TaskLogic.class.getMethod(entity.getMethod());
        method.invoke(taskLogic);

    }
}